Code

Merge branch 'np/types'
[git.git] / git-commit.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [[-i | -o] <path>...]'
7 SUBDIRECTORY_OK=Yes
8 . git-sh-setup
9 require_work_tree
11 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
13 case "$0" in
14 *status)
15         status_only=t
16         ;;
17 *commit)
18         status_only=
19         ;;
20 esac
22 refuse_partial () {
23         echo >&2 "$1"
24         echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
25         exit 1
26 }
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
30 rm -f "$NEXT_INDEX"
31 save_index () {
32         cp -p "$THIS_INDEX" "$NEXT_INDEX"
33 }
35 run_status () {
36         # If TMP_INDEX is defined, that means we are doing
37         # "--only" partial commit, and that index file is used
38         # to build the tree for the commit.  Otherwise, if
39         # NEXT_INDEX exists, that is the index file used to
40         # make the commit.  Otherwise we are using as-is commit
41         # so the regular index file is what we use to compare.
42         if test '' != "$TMP_INDEX"
43         then
44                 GIT_INDEX_FILE="$TMP_INDEX"
45                 export GIT_INDEX_FILE
46         elif test -f "$NEXT_INDEX"
47         then
48                 GIT_INDEX_FILE="$NEXT_INDEX"
49                 export GIT_INDEX_FILE
50         fi
52         case "$status_only" in
53         t) color= ;;
54         *) color=--nocolor ;;
55         esac
56         git-runstatus ${color} \
57                 ${verbose:+--verbose} \
58                 ${amend:+--amend} \
59                 ${untracked_files:+--untracked}
60 }
62 trap '
63         test -z "$TMP_INDEX" || {
64                 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
65         }
66         rm -f "$NEXT_INDEX"
67 ' 0
69 ################################################################
70 # Command line argument parsing and sanity checking
72 all=
73 also=
74 only=
75 logfile=
76 use_commit=
77 amend=
78 edit_flag=
79 no_edit=
80 log_given=
81 log_message=
82 verify=t
83 quiet=
84 verbose=
85 signoff=
86 force_author=
87 only_include_assumed=
88 untracked_files=
89 while case "$#" in 0) break;; esac
90 do
91         case "$1" in
92         -F|--F|-f|--f|--fi|--fil|--file)
93                 case "$#" in 1) usage ;; esac
94                 shift
95                 no_edit=t
96                 log_given=t$log_given
97                 logfile="$1"
98                 shift
99                 ;;
100         -F*|-f*)
101                 no_edit=t
102                 log_given=t$log_given
103                 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
104                 shift
105                 ;;
106         --F=*|--f=*|--fi=*|--fil=*|--file=*)
107                 no_edit=t
108                 log_given=t$log_given
109                 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
110                 shift
111                 ;;
112         -a|--a|--al|--all)
113                 all=t
114                 shift
115                 ;;
116         --au=*|--aut=*|--auth=*|--autho=*|--author=*)
117                 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
118                 shift
119                 ;;
120         --au|--aut|--auth|--autho|--author)
121                 case "$#" in 1) usage ;; esac
122                 shift
123                 force_author="$1"
124                 shift
125                 ;;
126         -e|--e|--ed|--edi|--edit)
127                 edit_flag=t
128                 shift
129                 ;;
130         -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
131                 also=t
132                 shift
133                 ;;
134         -o|--o|--on|--onl|--only)
135                 only=t
136                 shift
137                 ;;
138         -m|--m|--me|--mes|--mess|--messa|--messag|--message)
139                 case "$#" in 1) usage ;; esac
140                 shift
141                 log_given=m$log_given
142                 if test "$log_message" = ''
143                 then
144                     log_message="$1"
145                 else
146                     log_message="$log_message
148 $1"
149                 fi
150                 no_edit=t
151                 shift
152                 ;;
153         -m*)
154                 log_given=m$log_given
155                 if test "$log_message" = ''
156                 then
157                     log_message=`expr "z$1" : 'z-m\(.*\)'`
158                 else
159                     log_message="$log_message
161 `expr "z$1" : 'z-m\(.*\)'`"
162                 fi
163                 no_edit=t
164                 shift
165                 ;;
166         --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
167                 log_given=m$log_given
168                 if test "$log_message" = ''
169                 then
170                     log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
171                 else
172                     log_message="$log_message
174 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
175                 fi
176                 no_edit=t
177                 shift
178                 ;;
179         -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
180         --no-verify)
181                 verify=
182                 shift
183                 ;;
184         --a|--am|--ame|--amen|--amend)
185                 amend=t
186                 log_given=t$log_given
187                 use_commit=HEAD
188                 shift
189                 ;;
190         -c)
191                 case "$#" in 1) usage ;; esac
192                 shift
193                 log_given=t$log_given
194                 use_commit="$1"
195                 no_edit=
196                 shift
197                 ;;
198         --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
199         --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
200         --reedit-messag=*|--reedit-message=*)
201                 log_given=t$log_given
202                 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
203                 no_edit=
204                 shift
205                 ;;
206         --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
207         --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
208         --reedit-message)
209                 case "$#" in 1) usage ;; esac
210                 shift
211                 log_given=t$log_given
212                 use_commit="$1"
213                 no_edit=
214                 shift
215                 ;;
216         -C)
217                 case "$#" in 1) usage ;; esac
218                 shift
219                 log_given=t$log_given
220                 use_commit="$1"
221                 no_edit=t
222                 shift
223                 ;;
224         --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
225         --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
226         --reuse-message=*)
227                 log_given=t$log_given
228                 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
229                 no_edit=t
230                 shift
231                 ;;
232         --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
233         --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
234                 case "$#" in 1) usage ;; esac
235                 shift
236                 log_given=t$log_given
237                 use_commit="$1"
238                 no_edit=t
239                 shift
240                 ;;
241         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
242                 signoff=t
243                 shift
244                 ;;
245         -q|--q|--qu|--qui|--quie|--quiet)
246                 quiet=t
247                 shift
248                 ;;
249         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
250                 verbose=t
251                 shift
252                 ;;
253         -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
254         --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
255         --untracked-file|--untracked-files)
256                 untracked_files=t
257                 shift
258                 ;;
259         --)
260                 shift
261                 break
262                 ;;
263         -*)
264                 usage
265                 ;;
266         *)
267                 break
268                 ;;
269         esac
270 done
271 case "$edit_flag" in t) no_edit= ;; esac
273 ################################################################
274 # Sanity check options
276 case "$amend,$initial_commit" in
277 t,t)
278         die "You do not have anything to amend." ;;
279 t,)
280         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
281                 die "You are in the middle of a merge -- cannot amend."
282         fi ;;
283 esac
285 case "$log_given" in
286 tt*)
287         die "Only one of -c/-C/-F/--amend can be used." ;;
288 *tm*|*mt*)
289         die "Option -m cannot be combined with -c/-C/-F/--amend." ;;
290 esac
292 case "$#,$also,$only,$amend" in
293 *,t,t,*)
294         die "Only one of --include/--only can be used." ;;
295 0,t,,* | 0,,t,)
296         die "No paths with --include/--only does not make sense." ;;
297 0,,t,t)
298         only_include_assumed="# Clever... amending the last one with dirty index." ;;
299 0,,,*)
300         ;;
301 *,,,*)
302         only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
303         also=
304         ;;
305 esac
306 unset only
307 case "$all,$also,$#" in
308 t,t,*)
309         die "Cannot use -a and -i at the same time." ;;
310 t,,[1-9]*)
311         die "Paths with -a does not make sense." ;;
312 ,t,0)
313         die "No paths with -i does not make sense." ;;
314 esac
316 ################################################################
317 # Prepare index to have a tree to be committed
319 case "$all,$also" in
320 t,)
321         if test ! -f "$THIS_INDEX"
322         then
323                 die 'nothing to commit (use "git add file1 file2" to include for commit)'
324         fi
325         save_index &&
326         (
327                 cd_to_toplevel &&
328                 GIT_INDEX_FILE="$NEXT_INDEX" &&
329                 export GIT_INDEX_FILE &&
330                 git-diff-files --name-only -z |
331                 git-update-index --remove -z --stdin
332         ) || exit
333         ;;
334 ,t)
335         save_index &&
336         git-ls-files --error-unmatch -- "$@" >/dev/null || exit
338         git-diff-files --name-only -z -- "$@"  |
339         (
340                 cd_to_toplevel &&
341                 GIT_INDEX_FILE="$NEXT_INDEX" &&
342                 export GIT_INDEX_FILE &&
343                 git-update-index --remove -z --stdin
344         ) || exit
345         ;;
346 ,)
347         case "$#" in
348         0)
349                 ;; # commit as-is
350         *)
351                 if test -f "$GIT_DIR/MERGE_HEAD"
352                 then
353                         refuse_partial "Cannot do a partial commit during a merge."
354                 fi
355                 TMP_INDEX="$GIT_DIR/tmp-index$$"
356                 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
358                 # Build a temporary index and update the real index
359                 # the same way.
360                 if test -z "$initial_commit"
361                 then
362                         cp "$THIS_INDEX" "$TMP_INDEX"
363                         GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
364                 else
365                         rm -f "$TMP_INDEX"
366                 fi || exit
368                 echo "$commit_only" |
369                 GIT_INDEX_FILE="$TMP_INDEX" \
370                 git-update-index --add --remove --stdin &&
372                 save_index &&
373                 echo "$commit_only" |
374                 (
375                         GIT_INDEX_FILE="$NEXT_INDEX"
376                         export GIT_INDEX_FILE
377                         git-update-index --remove --stdin
378                 ) || exit
379                 ;;
380         esac
381         ;;
382 esac
384 ################################################################
385 # If we do as-is commit, the index file will be THIS_INDEX,
386 # otherwise NEXT_INDEX after we make this commit.  We leave
387 # the index as is if we abort.
389 if test -f "$NEXT_INDEX"
390 then
391         USE_INDEX="$NEXT_INDEX"
392 else
393         USE_INDEX="$THIS_INDEX"
394 fi
396 case "$status_only" in
397 t)
398         # This will silently fail in a read-only repository, which is
399         # what we want.
400         GIT_INDEX_FILE="$USE_INDEX" git-update-index -q --unmerged --refresh
401         run_status
402         exit $?
403         ;;
404 '')
405         GIT_INDEX_FILE="$USE_INDEX" git-update-index -q --refresh || exit
406         ;;
407 esac
409 ################################################################
410 # Grab commit message, write out tree and make commit.
412 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
413 then
414         if test "$TMP_INDEX"
415         then
416                 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
417         else
418                 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
419         fi || exit
420 fi
422 if test "$log_message" != ''
423 then
424         echo "$log_message"
425 elif test "$logfile" != ""
426 then
427         if test "$logfile" = -
428         then
429                 test -t 0 &&
430                 echo >&2 "(reading log message from standard input)"
431                 cat
432         else
433                 cat <"$logfile"
434         fi
435 elif test "$use_commit" != ""
436 then
437         encoding=$(git config i18n.commitencoding || echo UTF-8)
438         git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
439         sed -e '1,/^$/d' -e 's/^    //'
440 elif test -f "$GIT_DIR/MERGE_MSG"
441 then
442         cat "$GIT_DIR/MERGE_MSG"
443 elif test -f "$GIT_DIR/SQUASH_MSG"
444 then
445         cat "$GIT_DIR/SQUASH_MSG"
446 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
448 case "$signoff" in
449 t)
450         need_blank_before_signoff=
451         tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
452         grep 'Signed-off-by:' >/dev/null || need_blank_before_signoff=yes
453         {
454                 test -z "$need_blank_before_signoff" || echo
455                 git-var GIT_COMMITTER_IDENT | sed -e '
456                         s/>.*/>/
457                         s/^/Signed-off-by: /
458                 '
459         } >>"$GIT_DIR"/COMMIT_EDITMSG
460         ;;
461 esac
463 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
464         echo "#"
465         echo "# It looks like you may be committing a MERGE."
466         echo "# If this is not correct, please remove the file"
467         echo "# $GIT_DIR/MERGE_HEAD"
468         echo "# and try again"
469         echo "#"
470 fi >>"$GIT_DIR"/COMMIT_EDITMSG
472 # Author
473 if test '' != "$use_commit"
474 then
475         pick_author_script='
476         /^author /{
477                 s/'\''/'\''\\'\'\''/g
478                 h
479                 s/^author \([^<]*\) <[^>]*> .*$/\1/
480                 s/'\''/'\''\'\'\''/g
481                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
483                 g
484                 s/^author [^<]* <\([^>]*\)> .*$/\1/
485                 s/'\''/'\''\'\'\''/g
486                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
488                 g
489                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
490                 s/'\''/'\''\'\'\''/g
491                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
493                 q
494         }
495         '
496         encoding=$(git config i18n.commitencoding || echo UTF-8)
497         set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
498         LANG=C LC_ALL=C sed -ne "$pick_author_script"`
499         eval "$set_author_env"
500         export GIT_AUTHOR_NAME
501         export GIT_AUTHOR_EMAIL
502         export GIT_AUTHOR_DATE
503 fi
504 if test '' != "$force_author"
505 then
506         GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
507         GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
508         test '' != "$GIT_AUTHOR_NAME" &&
509         test '' != "$GIT_AUTHOR_EMAIL" ||
510         die "malformed --author parameter"
511         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
512 fi
514 PARENTS="-p HEAD"
515 if test -z "$initial_commit"
516 then
517         rloga='commit'
518         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
519                 rloga='commit (merge)'
520                 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
521         elif test -n "$amend"; then
522                 rloga='commit (amend)'
523                 PARENTS=$(git-cat-file commit HEAD |
524                         sed -n -e '/^$/q' -e 's/^parent /-p /p')
525         fi
526         current="$(git-rev-parse --verify HEAD)"
527 else
528         if [ -z "$(git-ls-files)" ]; then
529                 echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
530                 exit 1
531         fi
532         PARENTS=""
533         rloga='commit (initial)'
534         current=''
535 fi
536 set_reflog_action "$rloga"
538 if test -z "$no_edit"
539 then
540         {
541                 echo ""
542                 echo "# Please enter the commit message for your changes."
543                 echo "# (Comment lines starting with '#' will not be included)"
544                 test -z "$only_include_assumed" || echo "$only_include_assumed"
545                 run_status
546         } >>"$GIT_DIR"/COMMIT_EDITMSG
547 else
548         # we need to check if there is anything to commit
549         run_status >/dev/null 
550 fi
551 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
552 then
553         rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
554         run_status
555         exit 1
556 fi
558 case "$no_edit" in
559 '')
560         case "${VISUAL:-$EDITOR},$TERM" in
561         ,dumb)
562                 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
563                 echo >&2 "Please supply the commit log message using either"
564                 echo >&2 "-m or -F option.  A boilerplate log message has"
565                 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
566                 exit 1
567                 ;;
568         esac
569         git-var GIT_AUTHOR_IDENT > /dev/null  || die
570         git-var GIT_COMMITTER_IDENT > /dev/null  || die
571         ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
572         ;;
573 esac
575 case "$verify" in
576 t)
577         if test -x "$GIT_DIR"/hooks/commit-msg
578         then
579                 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
580         fi
581 esac
583 if test -z "$no_edit"
584 then
585     sed -e '
586         /^diff --git a\/.*/{
587             s///
588             q
589         }
590         /^#/d
591     ' "$GIT_DIR"/COMMIT_EDITMSG
592 else
593     cat "$GIT_DIR"/COMMIT_EDITMSG
594 fi |
595 git-stripspace >"$GIT_DIR"/COMMIT_MSG
597 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
598         git-stripspace |
599         wc -l` &&
600    test 0 -lt $cnt
601 then
602         if test -z "$TMP_INDEX"
603         then
604                 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
605         else
606                 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
607                 rm -f "$TMP_INDEX"
608         fi &&
609         commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
610         rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
611         git-update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" &&
612         rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
613         if test -f "$NEXT_INDEX"
614         then
615                 mv "$NEXT_INDEX" "$THIS_INDEX"
616         else
617                 : ;# happy
618         fi
619 else
620         echo >&2 "* no commit message?  aborting commit."
621         false
622 fi
623 ret="$?"
624 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
625 if test -d "$GIT_DIR/rr-cache"
626 then
627         git-rerere
628 fi
630 if test "$ret" = 0
631 then
632         if test -x "$GIT_DIR"/hooks/post-commit
633         then
634                 "$GIT_DIR"/hooks/post-commit
635         fi
636         if test -z "$quiet"
637         then
638                 echo "Created${initial_commit:+ initial} commit $commit"
639                 git-diff-tree --shortstat --summary --root --no-commit-id HEAD --
640         fi
641 fi
643 exit "$ret"